#include <sys/types.h>
#include "uifconfig.h"

static char *uif_errlist[] = {
	"unknown ifconfig error",
	"unable to read interface list",
	"set primary address failed",
	"set interface flags failed",
	"set interface destination address failed",
	"set interface netmask failed",
	"set interface broadcast address failed",
	"retrieving interface primary address failed",
	"retrieving interface flags failed",
	"retrieving interface destination address failed",
	"retrieving interface netmask failed",
	"retrieving interface broadcast address failed",
	"unable to open interface",
};

char *
uif_strerror(int erv) {
	if(erv > UIFE_MAX)
		erv = 0;

	if(erv < UIFE_UNKNOWN)
		erv = 0;

	return(uif_errlist[erv]);
}
