#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <sys/types.h>
#include <setjmp.h>

#include "uifconfig.h"

extern char *masterr;

#define EXCEPT(e) { 					\
	assert(0);					\
}


void *xalloc(const int size) {
	void *ptr = (void *) malloc(size);

	if(!ptr) 
		EXCEPT(AllocError);

	return(ptr);
}

void *xcalloc(const int num, const int size) {
	void *ptr = (void *) xalloc(num * size);
	if(!ptr) 
		EXCEPT(AllocError);

	memset(ptr, 0, num * size);

	return(ptr);
}

void *xrealloc(void *ptr, size_t size) {
	ptr = realloc(ptr, size);
	if(!ptr) 
		EXCEPT(AllocError);

	return(ptr);
}

char *xstrdup(const char *str) {
	int len;
	char *s;

	assert(str);

	len = strlen(str) + 1;
	s = (char *) xalloc(len);
	if(!s) 
		EXCEPT(AllocError);
	
	memcpy(s, str, len);

	return(s);
}

u_char *xbufdup(u_char *b, int size) {
	u_char *n;
	
	assert(b);

	n = xalloc(size);
	memcpy(n, b, size);

	return(n);
}

u_int32_t *xulongdup(u_int32_t a) {
	return((u_int32_t *)xbufdup((u_char *) &a, sizeof(a)));
}

void xfree(void **p) {
	free(*p);
	*p = NULL;

	return;
}
